All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 [ -n "$VCSH_DEBUG" ] && set -x
4 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
5 [ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
8 if [ "$SELF" = 'bash' ] ||
9 [ "$SELF" = 'dash' ] ||
11 [ "$SELF" = 'zsh' ]; then
18 echo "usage: $SELF <args>
21 [<repo>] Clone from an existing repository
22 help Display this help text
23 delete Delete an existing repository
24 enter Enter repository; spawn new $SHELL
25 exit Exit repository; unset ENV
26 init <repo> Initialize a new repository
27 list List all repositories
29 <command> Use this repository
32 <repo> Seed .gitignore.d/<repo> from git ls-files
33 use <repo> Use repository; set ENV
35 <repo> <git command> Special command that allows you to run git commands
36 directly without having to type so much ;)" >&2
40 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
44 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
49 if [ ! -d "$GIT_DIR" ]; then
50 echo E: no repository found for "$VCSH_REPO_NAME" >&2
54 export GIT_WORK_TREE="$(git config --get core.worktree)"
55 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
60 verbose "init() begin"
62 echo "$SELF: fatal: $GIT_DIR exists" &&
64 export GIT_WORK_TREE="$HOME"
65 mkdir -p "$GIT_WORK_TREE"
66 cd "$GIT_WORK_TREE" ||
67 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
68 return 1) || return $?
71 git config core.worktree "$GIT_WORK_TREE"
72 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
73 touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
74 git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
85 if [ "$1" = 'clone' ]; then
89 [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
91 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
92 elif [ "$1" = 'delete' ] ||
96 [ "$1" = 'seed-gitignore' ] ||
97 [ "$1" = 'use' ]; then
98 [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
99 export VCSH_COMMAND="$1"
100 export VCSH_REPO_NAME="$2"
101 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
103 export VCSH_EXTERNAL_COMMAND="$*"
104 if [ "$VCSH_COMMAND" = 'run' ]; then
105 [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
107 elif [ "$1" = 'exit' ] ||
109 [ "$1" = 'list' ]; then
110 export VCSH_COMMAND="$1"
112 [ -z $1 ] && help && return 0
113 export VCSH_COMMAND='run'
114 export VCSH_REPO_NAME="$1"
115 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
116 [ -d $GIT_DIR ] || (help && return 1) || return 0
118 export VCSH_EXTERNAL_COMMAND="git $*"
122 for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
124 if [ ! -d "$check_directory" ]; then
125 if [ -e "$check_directory" ]; then
126 echo "$SELF: error: $check_directory exists but is not a directory" >&2
129 echo "$SELF: info: attempting to create $check_directory"
130 mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
136 if [ "$VCSH_COMMAND" = 'clone' ]; then
137 verbose "clone begin"
139 git remote add origin "$GIT_REMOTE"
140 git config branch.master.remote origin
141 git config branch.master.merge refs/heads/master
143 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
145 echo "$SELF: error: $object exists." &&
148 [ "$VCSH_CONFLICT" = '1' ] &&
149 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
150 echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
152 git merge origin/master
156 #elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
157 elif [ "$VCSH_COMMAND" = 'help' ]; then
160 elif [ "$VCSH_COMMAND" = 'delete' ]; then
161 verbose "delete begin"
165 echo "$SELF: info: This operation WILL DETROY DATA!"
166 files=$(git ls-files)
167 echo "These files will be deleted:
171 AGAIN, THIS WILL DELETE YOUR DATA!
172 To continue, type \"Yes, do as I say\""
174 [ "x$answer" = "xYes, do as I say" ] || return 1
175 for file in $files; do
176 rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
178 rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
182 elif [ "$VCSH_COMMAND" = 'enter' ]; then
183 verbose "enter begin"
189 elif [ "$VCSH_COMMAND" = 'exit' ]; then
191 # if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
192 # unset VCSH_NO_IGNORE_EOF
193 # setopt NO_IGNORE_EOF
195 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
197 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
201 elif [ "$VCSH_COMMAND" = 'init' ]; then
207 elif [ "$VCSH_COMMAND" = 'list' ]; then
209 for i in "$VCSH_BASE"/*.git; do
210 echo $(basename "$i" .git)
214 elif [ "$VCSH_COMMAND" = 'run' ]; then
217 $VCSH_EXTERNAL_COMMAND
221 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
222 verbose "seed-gitignore begin"
224 # Switching directory as this has to be executed from $HOME to be of any use.
225 # Going back into old directory at the end in case `vcsh use` is reactivated.
228 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
229 gitignores=$(for file in $(git ls-files); do
231 echo $file; new="${file%/*}"
232 [ "$file" = "$new" ] && break
236 tempfile=$(mktemp) ||
237 (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
238 echo '*' > "$tempfile"
239 for gitignore in $gitignores; do
240 echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
241 [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
243 diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
246 if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
247 echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
248 mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
249 (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
250 return 1) || return $?
252 mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
253 (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
255 verbose "seed-gitignore end"
257 elif [ "$VCSH_COMMAND" = 'use' ]; then
259 # if [ -n "$ZSH_VERSION" ]; then
260 # if [ -o NO_IGNORE_EOF ]; then
261 # export VCSH_NO_IGNORE_EOF=1
269 # bindkey '^d' 'vcsh_exit'
271 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
273 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
277 verbose "defaulting to calling help()"
279 echo "$SELF: fatal: You should never reach this code. File a bug, please."